#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <pthread.h>
#include <signal.h>
#include <dirent.h>
#include <unistd.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern struct dirent **dirent_isplist;
extern GtkTextBuffer *txt_log_buf;
void tail (GtkTextBuffer *txt);
extern int pppd_pid;

pthread_t tail_thread;

/* FIXME: insert a callback for txt_log when change happens in order to scroll
   the scrollwindow  */

void
on_btn_about_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *win_about;

  win_about = create_win_about ();
  gtk_widget_show (win_about);
}


void
on_btn_dial_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  static GtkWidget *win_log;
  char *pppd_string;
  static char c = 0;

  if (!c) {
    win_log = create_win_log ();
    c = 1;
  }
  gtk_widget_show (win_log);
  gtk_widget_hide (gtk_widget_get_parent(gtk_widget_get_parent((GtkWidget *)button)));
  pppd_string = malloc(11 +
                strlen(dirent_isplist[gtk_combo_box_get_active((GtkComboBox *)user_data)]->d_name));
  sprintf (pppd_string, "pppd call %s",
          dirent_isplist[gtk_combo_box_get_active((GtkComboBox *)user_data)]->d_name);
  system (pppd_string);

  /* FIXME: Here or in tail.c it should check whether pppd launches ok,
     sometimes it causes abnormal program termination and other problems */

  pthread_create (&tail_thread, NULL, tail, txt_log_buf);
}

void
on_btn_disconnect_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkTextIter start, end;

  kill (pppd_pid, 15);

  /* FIXME: Now it should wait until pppd killing is complete, thus reading the
     log file... see also the parse() function in tail.c */

  gtk_text_buffer_get_iter_at_offset (txt_log_buf, &start, 0);
  gtk_text_buffer_get_iter_at_offset (txt_log_buf, &end,
                                  gtk_text_buffer_get_char_count (txt_log_buf));

  gtk_text_buffer_delete (txt_log_buf, &start, &end);
  gtk_widget_show ((GtkWidget *)user_data);
  gtk_widget_hide (gtk_widget_get_parent((GtkWidget *)button));

  /* FIXME: Kill tailing thread */
}

void
on_win_main_destroy                    (GtkButton       *button,
                                        gpointer         user_data)
{
  exit(0);
}

void
on_win_log_destroy                     (GtkButton       *button,
                                        gpointer         user_data)
{
  exit(0);
}
