#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <dirent.h>

#include <gnome.h>

#include "interface.h"
#include "support.h"

struct dirent **dirent_isplist;
int n;

int dirent_filter (const struct dirent *file) {
  if (strcmp(file->d_name, ".") && strcmp(file->d_name, ".."))
    return 1;
  return 0;
}

int
main (int argc, char *argv[])
{
  GtkWidget *win_main;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);

  if (!(n = scandir("/etc/ppp/peers", &dirent_isplist, dirent_filter,
                    alphasort))) {
    win_main = gtk_message_dialog_new (NULL, GTK_DIALOG_MODAL,
                                       GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                                       "PPP is not correctly configured!");
    gtk_dialog_run ((GtkDialog*) win_main);
    exit(0);
  }

  win_main = create_win_main ();
  gtk_widget_show (win_main);

  gtk_main ();
  free(dirent_isplist);
  return 0;
}
